﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;

namespace pr246_1
{
    class Program
    {
        // Статический метод для заполнения двумерного массива 
        // случайными числами:
        static void fill(int[,] a, int k, Random rnd) {
            // Объектная переменная для потока:
            Thread t = null;
            // Если не последняя строка: 
            if (k < a.GetLength(0) - 1) {
                // Создание объекта потока: 
                t = new Thread(()=>{
                    // Вызов в потоке метода: 
                    fill(a, k + 1, rnd);
                });
                // Запуск потока на выполнение: 
                t.Start();
            }
            // Заполнение строки в массиве: 
            for (int m = 0; m < a.GetLength(1); m++) {
                // Значение элемента - случайное число: 
                a[k, m] = k * 10 + rnd.Next(10);
            }
            // Если объект потока существует и поток еще 
            // выполняется, то необходимо дождаться 
            // завершения потока: 
            if (t != null && t.IsAlive) t.Join();
        }

        // Главный метод:
        static void Main()
        {
            // Создается двумерный массив: 
            int[,] nums = new int[6, 9];
            // Объект для генерации случайных чисел:
            Random rnd = new Random();
            // Заполнение массива: 
            fill(nums, 0, rnd);
            // Отображение содержимого массива: 
            for (int i = 0; i < nums.GetLength(0); i++)
            {
                for (int j = 0; j < nums.GetLength(1); j++)
                {
                    Console.Write("{0,-4}", nums[i, j]);
                }
                Console.WriteLine();
            }
        }
    }
}
